<?php
// vim:filetype=php expandtab tabstop=2 softtabstop=2 shiftwidth=2 autoindent smartindent

function tribune_url_info() {
  $info = array(
    'description' => t("Turns 'http://...' into clickable links."),
    'weight'      => 0,
  );

  return $info;
}

function tribune_url_filter_after(&$post, &$help) {
  $post['parsed'] = preg_replace_callback('#'.
      '('.                                        // 1
        '(https?|ftp|gopher|file|mms|rtsp|rtmp)'. // 2
        '://.*?'.
      ')'.
      '('.                                        // 3
        '(,|\.|\)|\]|\})?'.                       // 4
        '(<| | |"|$)'.                            // 5
      ')'.
      '#', 'tribune_url_replace', $post['parsed']);
}

function tribune_url_replace($matches) {
  $url = $matches[1];
  $text = 'url';

  $pairs = array(
    ')' => '(',
    '}' => '{',
    ']' => '[',
  );

  $before = "";
  $after  = "";

  if ($matches[4]) {
    if (isset($pairs[$matches[4]]) && substr_count($url, $pairs[$matches[4]]) == substr_count($url, $matches[4]) + 1) {
      $url .= $matches[4];
    } else {
      $after = $matches[4];
    }
  }

  $after .= $matches[5];

  foreach (explode("\n", tribune_variable_get('tribune_url_replacement', "")) as $line) {
    preg_match(':^/(.*[^\\\\])/(.*)$:U', trim($line), $result);

    if (count($result) == 3) {
      $rmatches = array();
      if (@preg_match('/'. $result[1] .'/', $url, $rmatches)) {
        $text = trim($result[2]);
        foreach ($rmatches as $key => $value) {
          $text = str_replace('$'.$key, $value, $text);
        }
      }
    }
  }

  $extra = '';
  if (tribune_variable_get('tribune_new_windows', TRUE)) {
    $extra .= ' target="_blank"';
  }

  return $before .'<a href="'. $url .'"' . $extra . '>['. $text .']</a>'. $after;
}

function tribune_url_settings() {
  $form = array();

  $form['tribune_new_windows'] = array(
    '#type'           => 'checkbox',
    '#title'          => t("Open links in new windows"),
    '#default_value'  => tribune_variable_get('tribune_new_windows', TRUE),
    '#description'    => t('If this box is checked, links will open in new windows (with target="_blank") instead of opening in the same window.'),
  );

  $form['tribune_url_replacement'] = array(
    '#type'           => "textarea",
    '#title'          => t("URL replacement expressions"),
    '#default_value'  => tribune_variable_get('tribune_url_replacement', ""),
    '#description'    => t("Use this format: <code>/regexp/ replacement string</code><br />You can escape /'s in the regexp with a \.<br />If any url matches an expression (according to <code>!preg_match_url</code>), it will be replaced with <em>[replacement string]</em> instead of the default <em>[url]</em>. You can use backreferences: '$1' will be replaced with the first expression between parenthesis.", array('!preg_match_url' => l('preg_match', 'http://php.net/preg_match'))),
  );

  return tribune_settings_form($form);
}
